org.springframework.web.socket.config.annotation

## Class SockJsServiceRegistration

- java.lang.Object
- - org.springframework.web.socket.config.annotation.SockJsServiceRegistration

    public class SockJsServiceRegistration
    extends Object

A helper class for configuring SockJS fallback options for use with an `EnableWebSocket` and `WebSocketConfigurer` setup.

Since:
  4.0
Author:
  Rossen Stoyanchev

### Constructor Summary

Constructors
Constructor and Description
`SockJsServiceRegistration()`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected SockJsService` `getSockJsService()`
`protected org.springframework.scheduling.TaskScheduler` `getTaskScheduler()` Return the TaskScheduler, if configured.
`protected SockJsServiceRegistration` `setAllowedOrigins(String... allowedOrigins)` Configure allowed `Origin` header values.
`SockJsServiceRegistration` `setClientLibraryUrl(String clientLibraryUrl)` Transports with no native cross-domain communication (e.g.
`SockJsServiceRegistration` `setDisconnectDelay(long disconnectDelay)` The amount of time in milliseconds before a client is considered disconnected after not having a receiving connection, i.e.
`SockJsServiceRegistration` `setHeartbeatTime(long heartbeatTime)` The amount of time in milliseconds when the server has not sent any messages and after which the server should send a heartbeat frame to the client in order to keep the connection from breaking.
`SockJsServiceRegistration` `setHttpMessageCacheSize(int httpMessageCacheSize)` The number of server-to-client messages that a session can cache while waiting for the next HTTP polling request from the client.
`SockJsServiceRegistration` `setInterceptors(HandshakeInterceptor... interceptors)`
`SockJsServiceRegistration` `setMessageCodec(SockJsMessageCodec codec)` The codec to use for encoding and decoding SockJS messages.
`SockJsServiceRegistration` `setSessionCookieNeeded(boolean sessionCookieNeeded)` The SockJS protocol requires a server to respond to the initial "/info" request from clients with a "cookie_needed" boolean property that indicates whether the use of a JSESSIONID cookie is required for the application to function correctly, e.g.
`SockJsServiceRegistration` `setStreamBytesLimit(int streamBytesLimit)` Streaming transports save responses on the client side and don't free memory used by delivered messages.
`SockJsServiceRegistration` `setSupressCors(boolean suppressCors)` This option can be used to disable automatic addition of CORS headers for SockJS requests.
`SockJsServiceRegistration` `setTaskScheduler(org.springframework.scheduling.TaskScheduler scheduler)` A scheduler instance to use for scheduling SockJS heart-beats.
`SockJsServiceRegistration` `setTransportHandlerOverrides(TransportHandler... handlers)`
`SockJsServiceRegistration` `setTransportHandlers(TransportHandler... handlers)`
`SockJsServiceRegistration` `setWebSocketEnabled(boolean webSocketEnabled)` Some load balancers don't support WebSocket.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SockJsServiceRegistration

    public SockJsServiceRegistration()

### Method Detail

#### setTaskScheduler

    public SockJsServiceRegistration setTaskScheduler(org.springframework.scheduling.TaskScheduler scheduler)

A scheduler instance to use for scheduling SockJS heart-beats.

#### setClientLibraryUrl

    public SockJsServiceRegistration setClientLibraryUrl(String clientLibraryUrl)

Transports with no native cross-domain communication (e.g. "eventsource", "htmlfile") must get a simple page from the "foreign" domain in an invisible iframe so that code in the iframe can run from a domain local to the SockJS server. Since the iframe needs to load the SockJS javascript client library, this property allows specifying where to load it from.

By default this is set to point to "https://cdn.jsdelivr.net/sockjs/0.3.4/sockjs.min.js". However it can also be set to point to a URL served by the application.

Note that it's possible to specify a relative URL in which case the URL must be relative to the iframe URL. For example assuming a SockJS endpoint mapped to "/sockjs", and resulting iframe URL "/sockjs/iframe.html", then the the relative URL must start with "../../" to traverse up to the location above the SockJS mapping. In case of a prefix-based Servlet mapping one more traversal may be needed.

#### setStreamBytesLimit

    public SockJsServiceRegistration setStreamBytesLimit(int streamBytesLimit)

Streaming transports save responses on the client side and don't free memory used by delivered messages. Such transports need to recycle the connection once in a while. This property sets a minimum number of bytes that can be send over a single HTTP streaming request before it will be closed. After that client will open a new request. Setting this value to one effectively disables streaming and will make streaming transports to behave like polling transports.

The default value is 128K (i.e. 128 * 1024).

#### setSessionCookieNeeded

    public SockJsServiceRegistration setSessionCookieNeeded(boolean sessionCookieNeeded)

The SockJS protocol requires a server to respond to the initial "/info" request from clients with a "cookie_needed" boolean property that indicates whether the use of a JSESSIONID cookie is required for the application to function correctly, e.g. for load balancing or in Java Servlet containers for the use of an HTTP session.

This is especially important for IE 8,9 that support XDomainRequest -- a modified AJAX/XHR -- that can do requests across domains but does not send any cookies. In those cases, the SockJS client prefers the "iframe-htmlfile" transport over "xdr-streaming" in order to be able to send cookies.

The default value is "true" to maximize the chance for applications to work correctly in IE 8,9 with support for cookies (and the JSESSIONID cookie in particular). However, an application can choose to set this to "false" if the use of cookies (and HTTP session) is not required.

#### setHeartbeatTime

    public SockJsServiceRegistration setHeartbeatTime(long heartbeatTime)

The amount of time in milliseconds when the server has not sent any messages and after which the server should send a heartbeat frame to the client in order to keep the connection from breaking.

The default value is 25,000 (25 seconds).

#### setDisconnectDelay

    public SockJsServiceRegistration setDisconnectDelay(long disconnectDelay)

The amount of time in milliseconds before a client is considered disconnected after not having a receiving connection, i.e. an active connection over which the server can send data to the client.

The default value is 5000.

#### setHttpMessageCacheSize

    public SockJsServiceRegistration setHttpMessageCacheSize(int httpMessageCacheSize)

The number of server-to-client messages that a session can cache while waiting for the next HTTP polling request from the client. All HTTP transports use this property since even streaming transports recycle HTTP requests periodically.

The amount of time between HTTP requests should be relatively brief and will not exceed the allows disconnect delay (see `setDisconnectDelay(long)`), 5 seconds by default.

The default size is 100.

#### setWebSocketEnabled

    public SockJsServiceRegistration setWebSocketEnabled(boolean webSocketEnabled)

Some load balancers don't support WebSocket. This option can be used to disable the WebSocket transport on the server side.

The default value is "true".

#### setTransportHandlers

    public SockJsServiceRegistration setTransportHandlers(TransportHandler... handlers)

#### setTransportHandlerOverrides

    public SockJsServiceRegistration setTransportHandlerOverrides(TransportHandler... handlers)

#### setInterceptors

    public SockJsServiceRegistration setInterceptors(HandshakeInterceptor... interceptors)

#### setAllowedOrigins

    protected SockJsServiceRegistration setAllowedOrigins(String... allowedOrigins)

Configure allowed `Origin` header values.

Since:
  4.1.2

#### setSupressCors

    public SockJsServiceRegistration setSupressCors(boolean suppressCors)

This option can be used to disable automatic addition of CORS headers for SockJS requests.

The default value is "false".

Since:
  4.1.2

#### setMessageCodec

    public SockJsServiceRegistration setMessageCodec(SockJsMessageCodec codec)

The codec to use for encoding and decoding SockJS messages.

By default `Jackson2SockJsMessageCodec` is used requiring the Jackson library to be present on the classpath.

Parameters:
  `codec` - the codec to use.
Since:
  4.1

#### getSockJsService

    protected SockJsService getSockJsService()

#### getTaskScheduler

    @Nullable
    protected org.springframework.scheduling.TaskScheduler getTaskScheduler()

Return the TaskScheduler, if configured.